import { BaseQuery } from './BaseQuery';
import { BaseTimeDimension } from './BaseTimeDimension';
export declare class ClickHouseQuery extends BaseQuery {
    newFilter(filter: any): any;
    escapeColumnName(name: any): string;
    convertTz(field: any): string;
    timeGroupedColumn(granularity: any, dimension: any): string;
    /**
     * Returns sql for source expression floored to timestamps aligned with
     * intervals relative to origin timestamp point.
     */
    dateBin(interval: string, source: string, origin: string): string;
    subtractInterval(date: string, interval: string): string;
    addInterval(date: string, interval: string): string;
    /**
     * The input interval with (possible) plural units, like "2 years", "3 months", "4 weeks", "5 days"...
     * will be converted to ClickHouse form of sum of single intervals.
     * @see https://clickhouse.com/docs/en/sql-reference/data-types/special-data-types/interval
     */
    private formatInterval;
    timeStampCast(value: string): string;
    dateTimeCast(value: string): string;
    dimensionsJoinCondition(leftAlias: any, rightAlias: any): string;
    getFieldAlias(id: any): any;
    orderHashToString(hash: any): string | null;
    groupByClause(): string;
    primaryKeyCount(cubeName: any, distinct: any): string;
    castToString(sql: any): string;
    seriesSql(timeDimension: BaseTimeDimension): string;
    concatStringsSql(strings: any): string;
    unixTimestampSql(): string;
    preAggregationLoadSql(cube: any, preAggregation: any, tableName: any): any[];
    countDistinctApprox(sql: string): string;
    createIndexSql(indexName: any, tableName: any, escapedColumns: any): string;
    sqlTemplates(): any;
}
//# sourceMappingURL=ClickHouseQuery.d.ts.map